Botan 1.10.17

Public Member Functions | List of all members
Botan::LubyRackoff Class Reference

`#include <lubyrack.h>`

Inheritance diagram for Botan::LubyRackoff:

## Public Member Functions
size_t | block_size () const
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
| LubyRackoff (HashFunction *hash)
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
virtual size_t | parallelism () const
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const
| ~LubyRackoff ()

## Detailed Description

Luby-Rackoff block cipher construction

Definition at line 19 of file lubyrack.h.

## Constructor & Destructor Documentation

## ◆ LubyRackoff()

Botan::LubyRackoff::LubyRackoff | ( | HashFunction * | hash | ) |

Parameters

  hash | function to use to form the block cipher

Definition at line 127 of file lubyrack.cpp.

Referenced by clone().

127 : hash(h)
128 {
129 }

## ◆ ~LubyRackoff()

Botan::LubyRackoff::~LubyRackoff | ( |  | ) |
| inline

Definition at line 40 of file lubyrack.h.

40 { delete hash; }

## Member Function Documentation

## ◆ block_size()

size_t Botan::LubyRackoff::block_size | ( |  | ) | const
| inline virtual

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 25 of file lubyrack.h.

25 { return 2 * hash->output_length(); }
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## ◆ clear()

void Botan::LubyRackoff::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 101 of file lubyrack.cpp.

References Botan::Algorithm::clear(), and Botan::zeroise().

102 {
103 zeroise(K1);
104 zeroise(K2);
105 hash->clear();
106 }
Botan::Algorithm::clear
virtual void clear()=0
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428

## ◆ clone()

BlockCipher * Botan::LubyRackoff::clone | ( |  | ) | const
| virtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 111 of file lubyrack.cpp.

References Botan::HashFunction::clone(), and LubyRackoff().

112 {
113 return new LubyRackoff(hash->clone());
114 }
Botan::LubyRackoff::LubyRackoff
LubyRackoff(HashFunction *hash)
Definition: lubyrack.cpp:127
Botan::HashFunction::clone
virtual HashFunction * clone() const =0

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inline inherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::LubyRackoff::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 53 of file lubyrack.cpp.

References Botan::Buffered_Computation::final(), Botan::Buffered_Computation::output_length(), Botan::Buffered_Computation::update(), and Botan::xor_buf().

54 {
55 const size_t len = hash->output_length();
56
57 SecureVector<byte> buffer_vec(len);
58 byte* buffer = &buffer_vec[0];
59
60 for(size_t i = 0; i != blocks; ++i)
61 {
62 hash->update(K2);
63 hash->update(in + len, len);
64 hash->final(buffer);
65 xor_buf(out, in, buffer, len);
66
67 hash->update(K1);
68 hash->update(out, len);
69 hash->final(buffer);
70 xor_buf(out + len, in + len, buffer, len);
71
72 hash->update(K2);
73 hash->update(out + len, len);
74 hash->final(buffer);
75 xor_buf(out, buffer, len);
76
77 hash->update(K1);
78 hash->update(out, len);
79 hash->final(buffer);
80 xor_buf(out + len, buffer, len);
81
82 in += 2 * len;
83 out += 2 * len;
84 }
85 }
Botan::byte
unsigned char byte
Definition: types.h:22
Botan::Buffered_Computation::update
void update(const byte in[], size_t length)
Definition: buf_comp.h:33
Botan::Buffered_Computation::final
void final(byte out[])
Definition: buf_comp.h:80
Botan::xor_buf
void xor_buf(byte out[], const byte in[], size_t length)
Definition: xor_buf.h:21
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::OFB::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inline inherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::LubyRackoff::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 16 of file lubyrack.cpp.

References Botan::Buffered_Computation::final(), Botan::Buffered_Computation::output_length(), Botan::Buffered_Computation::update(), and Botan::xor_buf().

17 {
18 const size_t len = hash->output_length();
19
20 SecureVector<byte> buffer_vec(len);
21 byte* buffer = &buffer_vec[0];
22
23 for(size_t i = 0; i != blocks; ++i)
24 {
25 hash->update(K1);
26 hash->update(in, len);
27 hash->final(buffer);
28 xor_buf(out + len, in + len, buffer, len);
29
30 hash->update(K2);
31 hash->update(out + len, len);
32 hash->final(buffer);
33 xor_buf(out, in, buffer, len);
34
35 hash->update(K1);
36 hash->update(out, len);
37 hash->final(buffer);
38 xor_buf(out + len, buffer, len);
39
40 hash->update(K2);
41 hash->update(out + len, len);
42 hash->final(buffer);
43 xor_buf(out, buffer, len);
44
45 in += 2 * len;
46 out += 2 * len;
47 }
48 }
Botan::byte
unsigned char byte
Definition: types.h:22
Botan::Buffered_Computation::update
void update(const byte in[], size_t length)
Definition: buf_comp.h:33
Botan::Buffered_Computation::final
void final(byte out[])
Definition: buf_comp.h:80
Botan::xor_buf
void xor_buf(byte out[], const byte in[], size_t length)
Definition: xor_buf.h:21
Botan::Buffered_Computation::output_length
virtual size_t output_length() const =0

## ◆ key_spec()

Key_Length_Specification Botan::LubyRackoff::key_spec | ( |  | ) | const
| inline virtual

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 27 of file lubyrack.h.

28 {
29 return Key_Length_Specification(2, 32, 2);
30 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::LubyRackoff::name | ( |  | ) | const
| virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 119 of file lubyrack.cpp.

References Botan::Algorithm::name().

120 {
121 return "Luby-Rackoff(" + hash->name() + ")";
122 }
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inline inherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inline virtual inherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::AES_256_NI, Botan::AES_192_NI, Botan::AES_128_NI, Botan::IDEA_SSE2, Botan::Noekeon_SIMD, Botan::Serpent_SIMD, and Botan::XTEA_SIMD.

Definition at line 30 of file block_cipher.h.

30 { return 1; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), and Botan::StreamCipher_Filter::StreamCipher_Filter().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), and Botan::Lion::Lion().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/lubyrack/lubyrack.h
- src/block/lubyrack/lubyrack.cpp